## Script (Python) "past_day_postings"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=days_ago, min_postings=0, max_postings=-1
##title=days_ago, min_postings, max_postings
##

#req = context.REQUEST

# "Test" tab args are always strings
days_ago = int(days_ago)
min_postings = int(min_postings)
max_postings = int(max_postings)

filter = context.get_posting_filter()
query = filter.buildQuery()
results = []

# We are not checking that query.date exists because it
# is an error to call this on a query that isn't date
# based and we want to let that error propagage.
start_date = query['date'] - days_ago

# Loop to ensure a minimum number of results.  Theoretically
# this should be endless, but hanging the server is bad...
for days in range(1, 5):
    end_date = start_date - (days * 6)
    query['date'] = (end_date, start_date)
    query['date_usage'] = 'range:min:max'

    results = context.postings_tool.applyFilter(filter, query_dict=query)
    if (not min_postings) or len(results) >= min_postings:
        # Normal return: we either have enough results or don't care
        return list(results)[0:max_postings]

# Error if we get this far.  Return whatever we could find.
context.log_('past_day_postings(%d, %d) only found %d postings' % \
             (days_ago, min_postings, len(results)))
return list(results)[0:max_postings]
